<img src="docs/images/image-banner.png" align="middle" width="3000"/>

# Unity ML-Agents Toolkit(Release 8) Türkçe Dokümantasyon Sayfası

[![docs badge](https://img.shields.io/badge/docs-reference-blue.svg)](https://github.com/Unity-Technologies/ml-agents/tree/release_7_docs/docs/)

[![license badge](https://img.shields.io/badge/license-Apache--2.0-green.svg)](LICENSE)

([son sürüm](https://github.com/Unity-Technologies/ml-agents/releases/tag/latest_release))
([tüm sürümler](https://github.com/Unity-Technologies/ml-agents/releases))

**Unity Machine Learning Agents Araç Seti** (ML-Agents) oyun ve simülasyon projeleri için akıllı ajanlar(botlar, etkiye uğrayan temsilciler) eğitecek ortamları sağlayan açık kaynaklı bir projedir. Ajanlar(Agents) pekiştirmeli öğrenme, taklit ederek öğrenme, nöroevrim veya diğer makine öğrenimi metodlarıyla kullanımı kolay Python API ile eğitilebilir. Ayrıca; oyun geliştiricilere ve hobi olarak yapanlara 2B, 3B ve VR / AR oyunlarına yönelik akıllı ajanları kolayca eğitmesini sağlamak için son teknoloji algoritmaları (TensorFlow tabanlı) kolayca uygulamalarını da sağlıyoruz. Bu eğitimli ajanlar(karakterler), NPC davranışı kontrol etme(çeşitli
çoklu bot ve rakip gibi ayarlanabilen), oyun yapılarının otomatik testleri, farklı oyun tasarımlarının yayın öncesi değerlendirilmesi gibi birden çok amaç için kullanılabilir. ML-Agents Araç Seti hem oyun geliştiricileri hem de yapay zeka araştırmacıları için karşılıklı olarak faydalıdır. Yapay zekadaki gelişmelerin Unity'nin zengin ortamlarında değerlendirilebileceği, daha geniş araştırma ve oyun geliştirici toplulukları için erişilebilir hale getirilebileceği merkezi bir platform sağlar.

**Kısacası;** Unity oyun motorunda kendi başına eğitildikleri yönde kararlar alabilen karakter, araç gibi objeleri eğitmemizi sağlayan bir araç setidir.


## Özellikleri

- 15+ [örnek Unity ortamları](docs/Learning-Environment-Examples.md)
- Birden çok ortam yapılandırması ve eğitim senaryosu desteği
- Oyununuza veya özel Unity sahnenize entegre edilebilen esnek Unity SDK
- İki derin güçlendirme öğrenme algoritması, Proximal Policy Optimization (PPO) ve
  Soft Actor-Critic (SAC) kullanarak eğitme
- Davranışsal Klonlama veya Üretken Tartışmalı Taklit Öğrenme yoluyla
  Taklit Öğrenme için yerleşik destek
- Düşman senaryolarında ajanları(agents) eğitmek için kendi kendine oyun mekanizması
- Karmaşık görevler için kolayca tanımlanabilen Müfredat Öğrenme(Curriculum Learning) senaryoları
- Rastgele ortamlar kullanarak kararlı ajanlar eğitin
- İsteğe Bağlı Karar Verme ile esnek ajan kontrolü
- Birden çok eş zamanlı Unity ortamı örneği kullanarak eğitim
- [Sentis](docs/Unity-Inference-Engine.md) desteği
- [Python API ile](docs/Python-API.md) Unity ortamını kontrol etme
- Unity - [gym](gym-unity/README.md) desteği

[ML-Agents Genel Bakış](docs/ML-Agents-Overview.md) sayfasında tüm özellikleri açıklanmıştır.

## Sürümler & Dokümantasyon

**Unity ML-Agents Araç Seti son kararlı sürümü `Release 8` 'dir.
[Buradan](docs/Readme.md) en son ML-Agents Türkçe dokümantasyonuna giderek öğrenmeye ve kullanmaya başlayabilirsiniz.**

- [Sürümler sayfasında](https://github.com/Unity-Technologies/ml-agents/releases) tüm versiyonları inceleyebilirsiniz.
- [Yapılan değişiklikler sayfasına](https://github.com/Unity-Technologies/ml-agents/blob/master/docs/Migrating.md) giderek güncellemelerle hangi özelliklerin değiştiğini inceleyebilirsiniz.
- [İngilizce](https://github.com/Unity-Technologies/ml-agents/blob/release_7_docs/docs/Readme.md) orjinal dokümantasyonuna linkten erişebilirsiniz.

## Makale

Bir YapayZeka platformu olarak Unity tartışmasıyla ilgilenen bir araştırmacıysanız, [Unity ve ML-Agents Toolkit](https://arxiv.org/abs/1809.02627) hakkındaki referans makalemizin bir ön baskısına bakın.

Ek kaynaklara [buradan](https://github.com/Unity-Technologies/ml-agents#additional-resources) ulaşabilirsiniz.

## Topluluk ve Geri Bildirim

Topluluğuza katılmak için [Unity ML-Agents forum](https://forum.unity.com/forums/ml-agents.453/) linkine veya [GitHub issue başvurusu](https://github.com/Unity-Technologies/ml-agents/issues) ile belirli özellik taleplerinde bulunabilirsiniz.

Diğer sorularınız veya geri bildirimleriniz için doğrudan ulaşabileceğiniz mail adresi : ml-agents@unity3d.com

Dokümantasyonu hazırlayan : Eydi Gözeneli
Hatalı çeviriler ve geri bildirim için iletişim : w3.eydi@gmail.com


## License

[Apache License 2.0](LICENSE)
