# Unity ML-Agents 工具包文档

## 入门
 * [ML-Agents 概述*](ML-Agents-Overview.md)
    * [背景：Unity](/docs/Background-Unity.md)
    * [背景：机器学习](/docs/Background-Machine-Learning.md)
    * [背景：TensorFlow](/docs/Background-TensorFlow.md)
 * [安装和设置*](Installation.md)
    * [背景：Jupyter Notebooks](/docs/Background-Jupyter.md)
    * [Docker 设置（测试功能）](/docs/Using-Docker.md)
 * [教你快速入门--3D Balance Ball 训练环境示例*](Getting-Started-with-Balance-Ball.md)
 * [官方训练环境示例*](Learning-Environment-Examples.md)

## 创建训练环境
 * [从头创建一个训练环境*](Learning-Environment-Create-New.md)
 * [设计训练环境*](Learning-Environment-Design.md)
     * [Agent](/docs/Learning-Environment-Design-Agents.md)
     * [Academy](/docs/Learning-Environment-Design-Academy.md)
     * [Brain](/docs/Learning-Environment-Design-Brains.md)：[Player](/docs/Learning-Environment-Design-Player-Brains.md)、[Heuristic](/docs/Learning-Environment-Design-Heuristic-Brains.md)、[Internal 和 External](/docs/Learning-Environment-Design-External-Internal-Brains.md)
 * [训练环境设计要点](/docs/Learning-Environment-Best-Practices.md)
 * [如何使用 Monitor 功能](/docs/Feature-Monitor.md)
 * [如何使用 TensorFlowSharp 插件（测试功能）](/docs/Using-TensorFlow-Sharp-in-Unity.md)

## 进行训练
 * [如何用 ML-Agents 进行训练](/docs/Training-ML-Agents.md)
 * [Proximal Policy Optimization 训练要点](/docs/Training-PPO.md)
 * [Curriculum Learning（课程学习）训练要点](/docs/Training-Curriculum-Learning.md)
 * [Imitation Learning（模仿学习）训练要点](/docs/Training-Imitation-Learning.md)
 * [LSTM 训练要点](/docs/Feature-Memory.md)
 * [如何使用 Amazon Web Services 进行云端训练](/docs/Training-on-Amazon-Web-Service.md)
 * [如何使用 Microsoft Azure 进行云端训练](/docs/Training-on-Microsoft-Azure.md)
 * [如何使用 TensorBoard 观察训练过程](/docs/Using-Tensorboard.md)

## 帮助
 * [如何从老版本升级到 ML-Agents v0.3](/docs/Migrating.md)
 * [常见问题](/docs/FAQ.md)
 * [ML-Agents 术语表](/docs/Glossary.md)
 * [ML-Agents 尚未实现功能](/docs/Limitations.md)

## API 文档
 * [API 参考](/docs/API-Reference.md)
 * [如何使用 Python API](/docs/Python-LLAPI.md)

**注:** 有翻译版的文档会在右上角标注*号。
